/**
* Copyright 2018 OSIsoft, LLC
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*  <http://www.apache.org/licenses/LICENSE-2.0>
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

import * as Models from './models';

export class PIEnumerationValue {
	public WebId?: string;
	public Id?: string;
	public Name?: string;
	public Description?: string;
	public Value?: number;
	public Path?: string;
	public Parent?: string;
	public Links?: Models.PIEnumerationValueLinks;
	public SerializeWebId?: boolean;
	public SerializeId?: boolean;
	public SerializeDescription?: boolean;
	public SerializePath?: boolean;
	public SerializeLinks?: boolean;
	public WebException?: Models.PIWebException;
	constructor(webId?: string, id?: string, name?: string, description?: string, value?: number, path?: string, parent?: string, links?: Models.PIEnumerationValueLinks, serializeWebId?: boolean, serializeId?: boolean, serializeDescription?: boolean, serializePath?: boolean, serializeLinks?: boolean, webException?: Models.PIWebException)
	{
		if (webId!=null)
		{
			this.WebId=webId
		}
		if (id!=null)
		{
			this.Id=id
		}
		if (name!=null)
		{
			this.Name=name
		}
		if (description!=null)
		{
			this.Description=description
		}
		if (value!=null)
		{
			this.Value=value
		}
		if (path!=null)
		{
			this.Path=path
		}
		if (parent!=null)
		{
			this.Parent=parent
		}
		if (links!=null)
		{
			this.Links=links
		}
		if (serializeWebId!=null)
		{
			this.SerializeWebId=serializeWebId
		}
		if (serializeId!=null)
		{
			this.SerializeId=serializeId
		}
		if (serializeDescription!=null)
		{
			this.SerializeDescription=serializeDescription
		}
		if (serializePath!=null)
		{
			this.SerializePath=serializePath
		}
		if (serializeLinks!=null)
		{
			this.SerializeLinks=serializeLinks
		}
		if (webException!=null)
		{
			this.WebException=webException
		}
	}
}
